//
//  AudioInteractor.swift
//  VKExt
//
//  Created programmist_NA on 23.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import SwiftyJSON
//import SwiftyVK
import RealmSwift
import VKAudioToken
import Alamofire
import ObjectMapper

class AudioInteractor: NSObject, AudioInteractorProtocol, URLSessionDownloadDelegate {
    private var params: CommonParams! = CommonParams()
    weak var presenter: AudioPresenterProtocol?
    var audioCount: Int = 0
    var items: [JSON] = []
    var indexPath: IndexPath?
    var service: AudioLoaderService?
    
    func start(token: String, secret: String, request: TestAudioItem.Model.Request.RequestType) {
        self.makeRequest(token: token, secret: secret, request: .getAudio)
        NotificationCenter.default.addObserver(self, selector: #selector(writeIndexPath), name: NSNotification.Name("onStartDownload"), object: nil)
    }
    
    func auth(login: String, password: String) {
        CommonService.instance.getSecretData(login: login, password: password, success: { (token, secret, deviceId) in
            UserDefaults.standard.set(token, forKey: "audioToken")
            UserDefaults.standard.set(secret, forKey: "secret")
            self.makeRequest(token: token, secret: secret, request: .getAudio)
        }, fail: { (error) in 
            self.presenter?.onLoaded(isErrored: true, errorCode: 1)
        })
    }
    
    func makeRequest(token: String, secret: String, request: TestAudioItem.Model.Request.RequestType) {
        if service == nil {
            service = AudioLoaderService()
        }
        
        switch request {
        case .getAudio:
            self.presenter?.presentData(response: .presentFooterLoader)
            service?.getAudio(token: token, secret: secret, ownerId: VKConstants.currentUserId, completion: { [weak self] (response) in
                guard let self = self else { return }
                self.presenter?.presentData(response: .presentAudio(audio: response.response))
                }, failed: { [weak self]  error in
                    guard let self = self else { return }
                    self.presenter?.presentData(response: .presentFooterError(message: error))
            })
        default:
            break
        }
    }
    
    func save(audio: Audio) {
        DispatchQueue(label: "saveAudio").async {
            if let audioUrl = URL(string: audio.url) {
                let documentsDirectoryURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first!
                
                let destinationUrl = documentsDirectoryURL.appendingPathComponent(audioUrl.lastPathComponent)
                print(audioUrl.lastPathComponent, destinationUrl)
                
                if FileManager.default.fileExists(atPath: destinationUrl.path) {
                    print("The file already exists at path")
                }  else {
                    let session = URLSession(configuration: URLSessionConfiguration.default, delegate: self, delegateQueue: nil)
                    let downloadTask = session.downloadTask(with: audioUrl)
                    downloadTask.resume()
                }
            }
        }
    }
    
    func storeFileLocally(at remoteUrl: URL, data: Data?) {
        // create your document folder url
        let documentsUrl = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask).first
        
        let destinationUrl = documentsUrl?.appendingPathComponent(remoteUrl.lastPathComponent)
        if let url = destinationUrl {
            do {
                try data?.write(to: url)
            }  catch let error as NSError {
                print(error.localizedDescription)
            }
        }
    }
    
    func urlSession(_ session: URLSession, downloadTask: URLSessionDownloadTask, didFinishDownloadingTo location: URL) {
        if let audioUrl = downloadTask.originalRequest?.url {
            let data = try? Data(contentsOf: location)
            storeFileLocally(at: audioUrl, data: data)
            
            DispatchQueue.main.async {
                self.presenter?.onEvent(message: "Аудиозапись загружена", .success)
                self.presenter?.onFinishDownload(at: self.indexPath!)
            }
        }
    }
    
    func urlSession(_ session: URLSession, downloadTask: URLSessionDownloadTask, didWriteData bytesWritten: Int64, totalBytesWritten: Int64, totalBytesExpectedToWrite: Int64) {
        let progress = Float(totalBytesWritten) / Float(totalBytesExpectedToWrite)
        DispatchQueue.main.async {
            self.presenter?.onProgressChanged(value: progress, at: self.indexPath!)
        }
    }
    
    @objc func writeIndexPath(_ notification: Notification) {
        indexPath = notification.userInfo?["indexPath"] as? IndexPath
    }
}
class ErrorModel: Mappable {
    var error: String!

    required init?(map: Map) {
        
    }
    
    func mapping(map: Map) {
        error <- map["error"]
    }
}
extension NSDictionary {
    func bv_jsonString(withPrettyPrint prettyPrint: Bool) -> String? {
        var _: ResponseError?
        var jsonData: Data? = nil
        do {
            jsonData = try JSONSerialization.data(withJSONObject: self, options: JSONSerialization.WritingOptions(rawValue: (prettyPrint ? JSONSerialization.WritingOptions.prettyPrinted.rawValue : 0)))
        } catch {
        }
        if jsonData == nil {
            return "{}"
        } else {
            if let jsonData = jsonData {
                return String(data: jsonData, encoding: .utf8)
            }
            return nil
        }
    }
}
